﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using IronRuby;
using Microsoft.Scripting.Hosting;
using System.Reflection;
using System.IO;

namespace IronRubyDrivenPhoneApplication
{
  public partial class MainPage : PhoneApplicationPage
  {
    // Constructor
    public MainPage()
    {
      InitializeComponent();

      SupportedOrientations = SupportedPageOrientation.PortraitOrLandscape;

      // Create an IronRuby engine and prevent compilation
      ScriptEngine engine = Ruby.CreateEngine();

      // Load the System.Windows.Media assembly to the IronRuby context
      engine.Runtime.LoadAssembly(typeof(Color).Assembly);

      // Add a global constant named Phone which will allow access to this class
      engine.Runtime.Globals.SetVariable("Phone", this);

      // Read the IronRuby code
      Assembly execAssembly = Assembly.GetExecutingAssembly();
      Stream codeFile = execAssembly.GetManifestResourceStream("IronRubyDrivenPhoneApplication.MainPage.rb");
      string code = new StreamReader(codeFile).ReadToEnd();

      // Execute the IronRuby code
      engine.Execute(code);
    }
  }
}
